/* Copyright (C) 2008 P.L. Lucas
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, 
 * Boston, MA 02111-1307, USA. 
 */



#include <gtk/gtk.h>
#include <glade/glade.h>
#include <vte/vte.h>
#include <vte/reaper.h>

#include "postscript_options.h"
#include "fit_xml.h"

static GladeXML *xml;
static GtkWidget *vte;
static gchar *datafile_name=NULL;



/*************************************************************************************************/
void on_open_data_button_clicked(GtkWidget *widget, gpointer user_data) {
	GtkWidget *entry=glade_xml_get_widget(xml,"file_entry");
	datafile_name=select_file("Select data file",datafile_name);
	if( datafile_name!= NULL )
		gtk_entry_set_text(GTK_ENTRY(entry), datafile_name);
}

/*************************************************************************************************/
void create_fit_options(GtkWidget *vte_widget){
	GError *error;
	GtkWidget *dialog;
	gint result;
	vte=vte_widget;
	/* load the interface */
    	/*xml = glade_xml_new(GLADE_FIT, NULL, NULL);*/
    	xml = glade_xml_new_from_buffer( fit_xml, strlen(fit_xml), NULL, NULL );
   	 if(xml==NULL) {
   	 	printf("Error: fit.glade not found.\n\n");
 	   	exit(0);
 	   }
 	   /* connect the signals in the interface */
 	glade_xml_signal_autoconnect(xml);
    	dialog=glade_xml_get_widget(xml,"dialog");
    	result=gtk_dialog_run(GTK_DIALOG(dialog));
    	if( result == GTK_RESPONSE_OK ) {
		char comando[5000];
		GtkWidget *aux;
		comando[0]='\0';
		strcat(comando,"f(x)=");
		aux=glade_xml_get_widget(xml,"function_entry");
		strcat(comando, gtk_editable_get_chars
				(GTK_EDITABLE(aux),0,-1));
		strcat(comando,"\nfit f(x) \"");
		aux=glade_xml_get_widget(xml,"file_entry");
		strcat(comando, gtk_editable_get_chars
				(GTK_EDITABLE(aux),0,-1));
		strcat(comando,"\" using ");
		aux=glade_xml_get_widget(xml,"cols_entry");
		strcat(comando, gtk_editable_get_chars
				(GTK_EDITABLE(aux),0,-1));
		strcat(comando," via ");
		aux=glade_xml_get_widget(xml,"parameters_entry");
		strcat(comando, gtk_editable_get_chars
				(GTK_EDITABLE(aux),0,-1));
		strcat(comando,"\n");
		vte_terminal_feed_child(VTE_TERMINAL(vte), comando, strlen(comando));
	}
	
	g_object_unref(xml);
	
	gtk_widget_destroy(dialog);
}
